ElementVisitor (Java Platform SE 8 )
Keywords: javax.lang.model.element.ElementVisitor interface
Date: 2017-07-29

compact3
javax.lang.model.element

## Interface ElementVisitor<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Known Implementing Classes:
    AbstractElementVisitor6, AbstractElementVisitor7, AbstractElementVisitor8, ElementKindVisitor6, ElementKindVisitor7, ElementKindVisitor8, ElementScanner6, ElementScanner7, ElementScanner8, SimpleElementVisitor6, SimpleElementVisitor7, SimpleElementVisitor8

      public interface ElementVisitor<R,P>

  A visitor of program elements, in the style of the visitor design pattern. Classes implementing this interface are used to operate on an element when the kind of element is unknown at compile time. When a visitor is passed to an element's `accept` method, the `visitXYZ` method most applicable to that element is invoked.

  Classes implementing this interface may or may not throw a `NullPointerException` if the additional parameter `p` is `null`; see documentation of the implementing class for details.

  WARNING: It is possible that methods will be added to this interface to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, visitor classes directly implementing this interface may be source incompatible with future versions of the platform. To avoid this source incompatibility, visitor implementations are encouraged to instead extend the appropriate abstract visitor class that implements this interface. However, an API should generally use this visitor interface as the type for parameters, return type, etc. rather than one of the abstract classes.

  Note that methods to accommodate new language constructs could be added in a source compatible way if they were added as default methods. However, default methods are only available on Java SE 8 and higher releases and the `javax.lang.model.*` packages bundled in Java SE 8 are required to also be runnable on Java SE 7. Therefore, default methods cannot be used when extending `javax.lang.model.*` to cover Java SE 8 language features. However, default methods may be used in subsequent revisions of the `javax.lang.model.*` packages that are only required to run on Java SE 8 and higher platform versions.

  Since:
    1.6
  See Also:
    `AbstractElementVisitor6`, `AbstractElementVisitor7`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `R` | `visit(Element e)` A convenience method equivalent to `v.visit(e, null)`.
    `R` | `visit(Element e, P p)` Visits an element.
    `R` | `visitExecutable(ExecutableElement e, P p)` Visits an executable element.
    `R` | `visitPackage(PackageElement e, P p)` Visits a package element.
    `R` | `visitType(TypeElement e, P p)` Visits a type element.
    `R` | `visitTypeParameter(TypeParameterElement e, P p)` Visits a type parameter element.
    `R` | `visitUnknown(Element e, P p)` Visits an unknown kind of element.
    `R` | `visitVariable(VariableElement e, P p)` Visits a variable element.

- - ### Method Detail

    - #### visit

          R visit(Element e,
                  P p)

      Visits an element.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visit

          R visit(Element e)

      A convenience method equivalent to `v.visit(e, null)`.
      Parameters:
        `e` - the element to visit
      Returns:
        a visitor-specified result

    - #### visitPackage

          R visitPackage(PackageElement e,
                         P p)

      Visits a package element.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitType

          R visitType(TypeElement e,
                      P p)

      Visits a type element.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitVariable

          R visitVariable(VariableElement e,
                          P p)

      Visits a variable element.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitExecutable

          R visitExecutable(ExecutableElement e,
                            P p)

      Visits an executable element.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitTypeParameter

          R visitTypeParameter(TypeParameterElement e,
                               P p)

      Visits a type parameter element.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result

    - #### visitUnknown

          R visitUnknown(Element e,
                         P p)

      Visits an unknown kind of element. This can occur if the language evolves and new kinds of elements are added to the `Element` hierarchy.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        a visitor-specified result
      Throws:
        `UnknownElementException` - a visitor implementation may optionally throw this exception

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2017, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.